routes/web.php
<?php

use App\Http\Controllers\AdminBookingController;
use App\Http\Controllers\BookController;
use App\Http\Controllers\BookingAdminController;
use App\Http\Controllers\BookingController;
use App\Http\Controllers\BorrowController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\StudentBorrowController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// student start
    // home
    Route::get('/', [HomeController::class, 'index'])->name('home');
    Route::get('home/show/{id}', [HomeController::class, 'show'])->name('home.user.show');
    Route::get('studentborrow', [StudentBorrowController::class, 'index'])->name('studentborrow.index');

    // booking
    Route::resource('booking', BookingController::class);
// student end

// admin start
    // dashboard
    Route::get('dashboard', [DashboardController::class, 'index'])->name('dashboard')->middleware('is_admin');

    // buku
    Route::resource('book', BookController::class)->middleware('is_admin');

    // category
    Route::resource('category', CategoryController::class)->middleware('is_admin');

    // borrow
    Route::get('borrow/{any}', [BorrowController::class, 'index'])->name('borrow.index')->middleware('is_admin');
    Route::post('borrow/', [BorrowController::class, 'store'])->name('borrow.store')->middleware('is_admin');
    Route::get('borrow/{id}/edit', [BorrowController::class, 'edit'])->name('borrow.edit')->middleware('is_admin');
    Route::put('borrow/{id}', [BorrowController::class, 'update'])->name('borrow.update')->middleware('is_admin');
    Route::delete('borrow/{id}/{any}', [BorrowController::class, 'destroy'])->name('borrow.destroy')->middleware('is_admin');

    // booking admin
    Route::resource('adminbooking', AdminBookingController::class)->middleware('is_admin');
    Route::get('adminbooking/create/{id}', [AdminBookingController::class, 'create'])->name('adminbooking.create')->middleware('is_admin');

    //user
    Route::middleware('is_admin')->group(function() {
        Route::get('user/{any}', [UserController::class, 'index'])->name('user.index');
        Route::get('user/show/{id}', [UserController::class, 'show'])->name('user.show');
        Route::delete('user/{id}/{any}', [UserController::class, 'destroy'])->name('user.destroy');
        Route::put('user/{id}', [UserController::class, 'update'])->name('user.update');
    });
// admin end

Auth::routes();

app/Models/Book.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Book extends Model
{
    use HasFactory;
}

app/Http/Controllers/BookController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\File;

class BookController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        // ambil data buku-buku
        $books = DB::table('books')
            ->select('books.*', 'categories.name as name')
            ->join('categories', 'books.category_id', '=', 'categories.id')
            ->orderBy('title')
            ->get();

        return view('pages.admin.book.index', [
            'books' => $books
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // ambil data kategori-kategori
        $categories = DB::table('categories')
            ->orderBy('name')
            ->get();

        return view('pages.admin.book.create', [
            'categories' => $categories
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // validasi
        $validatedData = $request->validate([
            'title' => 'required',
            'writer' => 'required',
            'publisher' => 'required',
            'year' => 'required|numeric|min:4',
            'category_id' => 'required',
            'cover' => 'mimes:png,jpg,jpeg|max:2048',
            'stock' => 'required',
        ]);

        // cover
        if ($request->hasfile('cover')) {
            // ganti nama
            $changeNameCover = uniqid('cvr-') . '.jpg';
            // pindahkan file
            $request->cover->move('images/covers/', $changeNameCover);
        } else {
            $changeNameCover = 'default.jpg';
        }

        // description
        if ($request->description == null) {
            $description = 'Deskripsi buku belum dibuat';
        } else {
            $description = $request->description;
        }

        // data tambahan
        $addData = [
            'description' => $description,
            'cover' => $changeNameCover,
            'created_at' => now(),
            'updated_at' => now(),
        ];

        // merge array
        $data = array_merge($validatedData, $addData);

        // simpan 
        DB::table('books')->insert($data);

        return redirect()->route('book.index')->with('pesan', 'Tambah buku berhasil');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        // ambil data buku-buku
        $book = DB::table('books')
            ->select('books.*', 'categories.name as name', 'categories.location as location', 'categories.floor as floor')
            ->join('categories', 'books.category_id', '=', 'categories.id')
            ->where('books.id', $id)
            ->first();

        return view('pages.admin.book.show', [
            'book' => $book
        ]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        // ambil data buku
        $book = DB::table('books')
            ->where('id', $id)
            ->first();

        // ambil data kategori-kategori
        $categories = DB::table('categories')
            ->orderBy('name')
            ->get();

        return view('pages.admin.book.edit', [
            'book' => $book,
            'categories' => $categories
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        // validasi
        $validatedData = $request->validate([
            'title' => 'required',
            'writer' => 'required',
            'publisher' => 'required',
            'year' => 'required|numeric|min:4',
            'category_id' => 'required',
            'cover' => 'mimes:png,jpg,jpeg|max:2048',
            'stock' => 'required',
        ]);

        // cover
        if ($request->hasfile('cover')) {
            // ganti nama
            $changeNameCover = uniqid('cvr-') . '.jpg';
            // pindahkan file
            $request->cover->move('images/covers/', $changeNameCover);
            // hapus file cover lama
            if ($request->coverOld != 'default.jpg') {
                File::delete('images/covers/' . $request->coverOld);
            }
        } else {
            $changeNameCover = $request->coverOld;
        }

        // description
        if ($request->description == null) {
            $description = 'Deskripsi buku belum dibuat';
        } else {
            $description = $request->description;
        }

        // data tambahan
        $addData = [
            'description' => $description,
            'cover' => $changeNameCover,
            'created_at' => now(),
            'updated_at' => now(),
        ];

        // merge array
        $data = array_merge($validatedData, $addData);

        // update 
        DB::table('books')
            ->where('id', $id)
            ->update($data);

        return redirect()->route('book.index')->with('pesan', 'Ubah buku berhasil');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        // ambil data buku
        $book = DB::table('books')
            ->where('id', $id)
            ->first();

        // hapus file cover
        if ($book->cover != 'default.jpg') {
            File::delete('images/covers/' . $book->cover);
        }

        // hapus data buku
        DB::table('books')
            ->where('id', $id)
            ->delete();

        return redirect()->route('book.index')->with('pesan', 'Hapus buku berhasil');
    }
}

resources/views/pages/admin/book/create.blade.php
@extends('layouts.admin')

@section('title', 'PerpustakaanXYZ | Tambah Buku')

@section('content')
<!-- Begin Page Content -->
<div class="container-fluid">

    {{-- breadcrumb --}}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ route('book.index') }}">Buku</a></li>
            <li class="breadcrumb-item active" aria-current="page">Tambah Buku</li>
        </ol>
    </nav>

    {{-- content --}}
    <div class="card shadow-sm">
        <div class="container py-4">

            <!-- Page Heading -->
            <h1 class="h3 mb-4 text-gray-800 text-center font-weight-bold">Tambah Buku</h1>

            <div class="row justify-content-center mb-4">
                <div class="col-md-10">

                    {{-- form --}}
                    <form action="{{ route('book.store') }}" method="post" enctype="multipart/form-data">
                        @csrf
                        <div class="form-group">
                            <label for="title">Judul</label>
                            <input type="text" class="form-control @error('title') is-invalid @enderror" id="title"
                                name="title" placeholder="Ex: Laskar Pelangi" value="{{ old('title') }}" autofocus>
                            @error('title')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="writer">Penulis</label>
                            <input type="text" class="form-control @error('writer') is-invalid @enderror" id="writer"
                                name="writer" placeholder="Ex: Andrea Hirata" value="{{ old('writer') }}">
                            @error('writer')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="publisher">Penerbit</label>
                            <input type="text" class="form-control @error('publisher') is-invalid @enderror"
                                id="publisher" name="publisher" placeholder="Ex: Bentang Pustaka"
                                value="{{ old('publisher') }}">
                            @error('publisher')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="year">Tahun Publikasi</label>
                            <input type="number" class="form-control @error('year') is-invalid @enderror" id="year"
                                name="year" placeholder="Ex: 2005" value="{{ old('year') }}">
                            @error('year')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="category_id">Kategori</label>
                            <select class="form-control @error('category_id') is-invalid @enderror" id="category_id"
                                name="category_id">
                                {{-- list kategori --}}
                                @forelse ($categories as $category)
                                <option value="{{ $category->id }}"
                                    {{ old('category_id') == $category->id ? 'selected' : '' }}>
                                    {{ $category->name }}
                                </option>
                                @empty
                                <option>Tidak ada data</option>
                                @endforelse
                            </select>
                            @error('category_id')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="cover">Sampul</label>
                            <input type="file" class="form-control" id="cover" name="cover">
                            @error('cover')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="description">Deskripsi</label>
                            <input type="hidden" class="@error('description') is-invalid @enderror" id="description"
                                name="description" placeholder="Ex: 10" value="{{ old('description') }}">
                            <trix-editor input="description"></trix-editor>
                            @error('description')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="stock">Stok</label>
                            <input type="number" class="form-control @error('stock') is-invalid @enderror" id="stock"
                                name="stock" placeholder="Ex: 10" value="{{ old('stock') }}">
                            @error('stock')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <button type="submit" class="btn btn-primary d-block w-100 text-center">Simpan</button>
                    </form>

                </div>
            </div>

        </div>
    </div>

</div>
<!-- /.container-fluid -->
@endsection

{{-- melampirkan push trix-editor --}}
@include('includes.trix')

resources/views/pages/admin/book/edit.blade.php
@extends('layouts.admin')

@section('title', 'PerpustakaanXYZ | Ubah Buku')

@section('content')
<!-- Begin Page Content -->
<div class="container-fluid">

    {{-- breadcrumb --}}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ route('book.index') }}">Buku</a></li>
            <li class="breadcrumb-item active" aria-current="page">Ubah Buku</li>
        </ol>
    </nav>

    {{-- content --}}
    <div class="card shadow-sm">
        <div class="container py-4">

            <!-- Page Heading -->
            <h1 class="h3 mb-4 text-gray-800 text-center font-weight-bold">Ubah Buku</h1>

            <div class="row justify-content-center mb-4">
                <div class="col-md-10">

                    {{-- form --}}
                    <form action="{{ route('book.update', $book->id) }}" method="post" enctype="multipart/form-data">
                        @csrf
                        @method('put')
                        <div class="form-group">
                            <label for="title">Judul</label>
                            <input type="text" class="form-control @error('title') is-invalid @enderror" id="title"
                                name="title" placeholder="Ex: Laskar Pelangi"
                                value="{{ old('title') ? old('title') : $book->title }}" autofocus>
                            @error('title')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="writer">Penulis</label>
                            <input type="text" class="form-control @error('writer') is-invalid @enderror" id="writer"
                                name="writer" placeholder="Ex: Andrea Hirata"
                                value="{{ old('writer') ? old('writer') : $book->writer }}">
                            @error('writer')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="publisher">Penerbit</label>
                            <input type="text" class="form-control @error('publisher') is-invalid @enderror"
                                id="publisher" name="publisher" placeholder="Ex: Bentang Pustaka"
                                value="{{ old('publisher') ? old('publisher') : $book->publisher }}">
                            @error('publisher')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="year">Tahun Publikasi</label>
                            <input type="number" class="form-control @error('year') is-invalid @enderror" id="year"
                                name="year" placeholder="Ex: 2005"
                                value="{{ old('year') ? old('year') : $book->year }}">
                            @error('year')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="category_id">Kategori</label>
                            <select class="form-control @error('category_id') is-invalid @enderror" id="category_id"
                                name="category_id">
                                {{-- list kategori --}}
                                @forelse ($categories as $category)
                                <option value="{{ $category->id }}"
                                    {{ (old('category_id') ?? $book->category_id) == $category->id ? 'selected' : '' }}>
                                    {{ $category->name }}
                                </option>
                                @empty
                                <option>Tidak ada data</option>
                                @endforelse
                            </select>
                            @error('category_id')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="cover">Sampul</label>
                            <div class="mb-3">
                                <img src="{{ asset('images/covers/' . $book->cover) }}" alt="{{ $book->title }}"
                                    class="img-sm">
                            </div>
                            <input type="hidden" name="coverOld" value="{{ $book->cover }}">
                            <input type="file" class="form-control" id="cover" name="cover">
                            @error('cover')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="description">Deskripsi</label>
                            <input type="hidden" class="@error('description') is-invalid @enderror" id="description"
                                name="description" placeholder="Ex: 10"
                                value="{{ old('description') ? old('description') : $book->description }}">
                            <trix-editor input="description"></trix-editor>
                            @error('description')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="stock">Stok</label>
                            <input type="number" class="form-control @error('stock') is-invalid @enderror" id="stock"
                                name="stock" placeholder="Ex: 10"
                                value="{{ old('stock') ? old('stock') : $book->stock }}">
                            @error('stock')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <button type="submit" class="btn btn-primary d-block w-100 text-center">Simpan</button>
                    </form>

                </div>
            </div>

        </div>
    </div>

</div>
<!-- /.container-fluid -->
@endsection

{{-- melampirkan push trix-editor --}}
@include('includes.trix')

resources/views/pages/admin/book/index.blade.php
@extends('layouts.admin')

@section('title', 'PerpustakaanXYZ | Buku')

@section('content')
<!-- Begin Page Content -->
<div class="container-fluid">

    <!-- Page Heading -->
    <h1 class="h3 mb-4 text-gray-800">Daftar Buku</h1>

    {{-- content --}}
    <div class="card shadow-sm">
        <div class="container py-4">

            {{-- pesan --}}
            @if (session()->has('pesan'))
            <div class="alert alert-success alert-dismissible fade show" role="alert">
                {{ session()->get('pesan') }}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            @endif

            {{-- button --}}
            <a href="{{ route('book.create') }}" class="btn btn-primary mb-3">Tambah Buku</a>

            {{-- table --}}
            <div class="table-responsive">
                <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                    <thead>
                        <tr>
                            <th>#</th>
                            <th>Sampul</th>
                            <th>Judul</th>
                            <th>Penulis</th>
                            <th>Kategori</th>
                            <th>Tahun</th>
                            <th>Stok</th>
                            <th>Aksi</th>
                        </tr>
                    </thead>
                    <tbody>

                        {{-- tampil data --}}
                        @forelse ($books as $book)
                        <tr>
                            <td>{{ $loop->iteration }}</td>
                            <td>
                                <img src="{{ asset('images/covers/' . $book->cover) }}" alt="{{ $book->title }}"
                                    class="img-sm">
                            </td>
                            <td>{{ $book->title }}</td>
                            <td>{{ $book->writer }}</td>
                            <td>{{ $book->name }}</td>
                            <td>{{ $book->year }}</td>
                            <td>{{ $book->stock }}</td>
                            <td class="d-flex justify-content-center">

                                {{-- read --}}
                                <a href="{{ route('book.show', $book->id) }}" class="btn btn-info mr-2" title="Detail">
                                    <i class="fas fa-eye"></i>
                                </a>

                                {{-- edit --}}
                                <a href="{{ route('book.edit', $book->id) }}" class="btn btn-secondary mr-2"
                                    title="Ubah">
                                    <i class="fas fa-edit"></i>
                                </a>

                                <!-- button delete modal -->
                                <button type="button" class="btn btn-danger btn-delete" data-toggle="modal"
                                    data-target="#deleteModal" data-id={{ $book->id }} title="Hapus">
                                    <i class="fas fa-trash"></i>
                                </button>

                            </td>
                        </tr>
                        @empty
                        <tr>
                            <td colspan="8" class="text-center">Tidak ada data</td>
                        </tr>
                        @endforelse

                    </tbody>
                </table>
            </div>

        </div>
    </div>

</div>
<!-- /.container-fluid -->
@endsection

{{-- melampirkan push deleteModal --}}
@include('includes.deleteModal')

{{-- melampirkan push css dan js datatables --}}
@include('includes.datatables')

{{-- push script deleteJS --}}
@push('scripts')
<script>
    // menangkap nilai id lalu mengeneratenya ke dalam url action form 
    $('.btn-delete').click(function () {
        let idDelete = $(this).attr('data-id');
        $('#deleteForm').attr('action', '/book/' + idDelete);
    })

    // jika ya ditekan, maka submit form
    $('#deleteForm [type="submit"]').click(function () {
        $('#deleteForm').submit();
    })

</script>
@endpush

resources/views/pages/admin/book/show.blade.php
@extends('layouts.admin')

@section('title', 'PerpustakaanXYZ | Detail Buku')

@section('content')
<!-- Begin Page Content -->
<div class="container-fluid">

    {{-- breadcrumb --}}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ route('book.index') }}">Buku</a></li>
            <li class="breadcrumb-item active" aria-current="page">Detail Buku</li>
        </ol>
    </nav>

    {{-- content --}}
    <div class="card shadow-sm">
        <div class="container py-4">

            {{-- page heading --}}
            <h1 class="h3 font-weight-bold text-gray-800 mb-4 text-center">{{ $book->title }}</h1>

            <div class="row justify-content-center mb-4">
                <div class="col-md-10">

                    {{-- detail --}}
                    <div class="mb-3 text-center">
                        <img src="{{ asset('images/covers/' . $book->cover) }}" alt="{{ $book->title }}" class="img-md">
                    </div>
                    <div class="text-center">
                        <p> <small>by.</small> <b>{{ $book->writer }}</b> <small>from</small>
                            <b>{{ $book->publisher }},
                                {{ $book->year }}</b></p>
                    </div>
                    <div class="mb-3">
                        <p class="font-weight-bold">Deskripsi</p>
                        <p>{!! $book->description !!}</p>
                    </div>
                    <div class="row justify-content-center">
                        <div class="col-md-4">
                            <p class="font-weight-bold">Kategori</p>
                            <p>{{ $book->name }}</p>
                        </div>
                        <div class="col-md-4">
                            <p class="font-weight-bold">Stok</p>
                            <p>{{ $book->stock }} Buah</p>
                        </div>
                        <div class="col-md-4">
                            <p class="font-weight-bold">Lokasi Penyimpanan</p>
                            <p>{{ $book->location }} (Lantai {{ $book->floor }})</p>
                        </div>
                    </div>

                </div>
            </div>

        </div>
    </div>

</div>
<!-- /.container-fluid -->
@endsection